/*************************************************************************
**                                                                      **
**                   H E L I O S   F I L E S E R V E R                  **
**                   ---------------------------------                  **
**                                                                      **
**                   Copyright (C) 1990, Parsytec GmbH                  **
**                          All Rights Reserved.                        **
**                                                                      **
** msc.h  								**
**                                                                      **
**	Definitions of the MSC driver parameters.			**
**									**
**************************************************************************
** HISTORY  :								**
**-----------								**
** Author   :  31/10/90  G.Lauven 					**
*************************************************************************/

#include <helios.h>
#include <sem.h>
#include <stdio.h>

#include <stdlib.h>

#include <syslib.h>
#include <device.h>
#include <codes.h>
#include <root.h>
#include <gsp.h>


#include "o_inter.h"
#include "chan_io.h"

#define	CURRENT_DIR	"/helios/lib"
#define	MSC_DRIVER	"msc02.gen"

#define	BLK_SIZE	4096	/* size of transfer unit to MSC */
#define	DUMMY_SIZE	32	/* size of dummy read buffer */
#define	COMMAND_SIZE	32	/* size of common command buffer */


#define daddr_t	word	/* disc address type */

typedef struct DiscDCB {
	DCB		DCB;
	Channel 	cmd_out, data_in, data_out, cmd_in, dum_1, dum_2;
	word 		dummy_buffer[DUMMY_SIZE];
 	word 		command[COMMAND_SIZE];
	bool 		ok;
	Semaphore	Lock;
} DiscDCB;

/* ==================================================================== */

#define	MSC_SCSI_ADDR	7	/* SCSI address of MSC board */
#define	WINNIES		1	/* number of winchester devices */
#define	FLOPPIES	0	/* number of floppy devices */
#define	STREAMER	0	/* number of streamer tapes */

#define	CLASS		1	/* Device class in init () */
#define	DEVICE		0	/* Device no in init () */
#define	DEV_TYPE	0	/* Device_type in init () */
#define PID		0	/* default pid number */
#define PRI		0	/* default priority */
#define LUN		0	/* default lun in init() */

/* ==================================================================== */

/* command tags for MSC protocol */

#define	CO_OK		0

#define	CO_SPECIAL	0
#define	CO_WINCH	1
#define	CO_FLOPPY	2

#define	CO_CLEAR	0
#define	CO_INIT		1
#define	CO_LOAD		2
#define	CO_READ		3
#define	CO_WRITE	4
#define	CO_FINISH	11
#define	CO_RESERVE	21
#define	CO_RELEASE	22



